# Purdue Gold IronHacks Spring 2017 Tutorials    

Welcome to Purdue Gold IronHacks Spring 2017! These pages aim to introduce you to various technologies that will be required as part of this programming challenge. We kindly ask you to complete the material before the competition starts on March 28th, 2017.

**[Introduction Slides - Purdue](https://www.dropbox.com/s/byi71e1dij5ljnt/3-7-2017_Purdue%20IronHacks%202017_Hack%20Introduction.pdf?dl=0)**
**[Introduction Slides - Bogota](https://www.dropbox.com/s/wxtj0885wsjwxua/3-2-2017_Purdue-UNAL%20IronHacks%202017_Hack%20Introduction.pdf?dl=0)**

## Session 1
<i><small>(please complete between March 6th to March 10th)</small></i>

**[Presentation](https://drive.google.com/open?id=1ROow9rDdBPrJkhUaoTVEoPvAm8mr1j7Xm4oaQH2u-d4)** -- Slides for Session 1
### HTML
**[Tutorial](http://www.w3schools.com/html)** -- An official tutorial for HTML<br>
**[Sample Project](session1/html&css)** -- Our simple project for HTML and CSS specifically developed for IronHacks<br>

### CSS
**[Tutorial](http://www.w3schools.com/css/)** -- An official tutorial for CSS<br>
**[Bootstrap](http://getbootstrap.com/)** -- Official website for Bootstrap<br>
**[Sample Project](session1/html&css)** -- Our simple project for HTML and CSS specifically developed for IronHacks<br>

### Videos for Sample Projects
**[HTML & CSS 1](https://www.youtube.com/watch?v=NgY0Cs09xyM&index=1&list=PLv0S1odRLm0YTt7EaxAQpiru6HJAymYJ-&t=572s)** <br>
**[HTML & CSS 2](https://www.youtube.com/watch?v=jYlHVKq7YKc&list=PLv0S1odRLm0YTt7EaxAQpiru6HJAymYJ-&index=2)** <br>

Please follow along these videos to complete the sample projects on HTML & CSS


**[Quiz - HTML & CSS](http://www.ironhacks.com/quizzes)**: Quiz “HTML & CSS” for week 1: We strongly recommend that you take this quiz. (sign-in to your contest)<br>

### GitHub

You are required to submit code to our system using GitHub <br>


**[Getting started](session1/Github/Github-Tutorial.md)** -- A simple introduction for Git and GitHub, such as how to install and basic usage<br>
**[Understanding GIT](https://www.atlassian.com/git/tutorials/what-is-git)** -- A good tutorial for Git

_In this hack, we will create a git repository for every participant, and add them as collaborators to their respective repo. All code submissions should done through the said repository_

## Session 2
<small><i>(please complete between March 20th to March 23th)</i></small>

**[Presentation](https://drive.google.com/open?id=1OYDpDXJI_I0kP3_MwuqNwsVqt2wb_JwlGoz0Eo7id30)** -- Slides for Session 2

### Javascript and jQuery
**[JS Tutorial](http://www.w3schools.com/js/)** -- An official tutorial for Javascript<br>
**[jQuery Tutorial](http://www.w3schools.com/jquery/)** -- An official tutorial for jQuery<br>
**[Sample Project](session2/)** -- Our simple project for Javascript and jQuery specifically developed for IronHacks<br>

### Videos for Sample Projects
**[JavaScript 1](https://www.youtube.com/watch?v=AhDO3xLwuC0&list=PLv0S1odRLm0aNn1kgeswUMAkFhOqzEZee&index=1)** <br>
**[JavaScript 2](https://www.youtube.com/watch?v=24AZUg6YY6w&list=PLv0S1odRLm0aNn1kgeswUMAkFhOqzEZee&index=2)** <br>
**[JavaScript 3](https://www.youtube.com/watch?v=hl71lGLlbbg&list=PLv0S1odRLm0aNn1kgeswUMAkFhOqzEZee&index=3)** <br>
**[jQuery 1](https://www.youtube.com/watch?v=qIo_F5qI7Qk&list=PLv0S1odRLm0aNn1kgeswUMAkFhOqzEZee&index=4)** <br>
**[jQuery 2](https://www.youtube.com/watch?v=0mtZJTIq1LU&list=PLv0S1odRLm0aNn1kgeswUMAkFhOqzEZee&index=5)** <br>
**[jQuery 3](https://www.youtube.com/watch?v=m6VhtLLJiCQ&list=PLv0S1odRLm0aNn1kgeswUMAkFhOqzEZee&index=6)** <br>

Please follow along these videos to complete the sample projects on Javascript & jQuery

**[Quiz - Javascript & jQuery](http://www.ironhacks.com/quizzes)**: Quiz “Javascript & jQuery” for week 2: We strongly recommend that you take this quiz (sign-in to your contest)<br>

## Session 3
<small><i>(please complete between March 24th to March 28th)</i></small>

**[Presentation](https://docs.google.com/presentation/d/1paSzazJEQV3jkrPDvGyM6wKifaGgkZwWRotKwvwMNy0/edit?usp=sharing)** -- Slides for Session 3

### d3.js and Google Maps
**[Tutorial](https://github.com/d3/d3/wiki)** -- An official tutorial for d3<br>
**[Sample Project](session3/D3_tutorial)** -- Our simple project for d3 specifically developed for IronHacks<br>

### Chart Libraries
You can use chart libraries to create beautiful visualizations <br>
**[Arbor.js](http://arborjs.org)** <br>
**[D3.js](http://d3js.org)**<br>
**[C3.js](http://c3js.org)**<br>
**[Sigma.js](http://sigmajs.org)**<br>

### Videos for Sample Projects
**[d3.js 1](https://drive.google.com/open?id=0B-DRvJb6N3IiLXZDSFR2ZHF5NFE)** <br>
**[d3.js 2](https://drive.google.com/open?id=0B-DRvJb6N3IiYm5hclVxRk9pcEE)** <br>
**[d3.js 3](https://drive.google.com/open?id=0B-DRvJb6N3Iic25BWkJ5eXpNb1E)** <br>
**[d3.js 4](https://drive.google.com/open?id=0B-DRvJb6N3IiVno4eGZQNnItMnM)** <br>

Please follow along these videos to complete the sample projects on d3

**[Quiz - d3](http://www.ironhacks.com/quizzes)**: Quiz “d3” for week 3: We strongly recommend that you take this quiz (sign-in to your contest)<br>

### Google Maps Javascript API
**[Official Tutorial](https://developers.google.com/maps/documentation/javascript/tutorial)** -- Official tutorial for Google Map API<br>
**[Sample Tutorial](session3/GoogleMap/Google-Maps-Tutorial.md)** -- Our sample tutorial for Google Map API specifically developed for IronHacks<br>
**[Official Project](https://developers.google.com/maps/documentation/javascript/earthquakes)** -- Official tutorial for Google Map API<br>

## Additional information to get ready for the hack that starts on March 28th, 2017

Purdue Gold IronHacks Spring 2017 will involve location data, so it is recommended that you go through the Google Maps Tutorial Guide (see above). Below, we provide you with information about open data sets, and also an example submission of a mashup (similar to one that you may submit in the first phase of the hack). For your reference, here is a definition of a **[mashup](https://techterms.com/definition/mashup)**

### 1. Datasets

The IRONHACKS rules require that you use at least TWO open data sets in your project. One dataset is mandatory

Available datasets to choose from:
- **[Climate Data Online](https://www.ncdc.noaa.gov/cdo-web)** -- the mandatory dataset <br>

Pick one additional open data set relevant for a challenge focused on the food quality and price:
- **[50OPENDATASETS](https://www.dropbox.com/s/xsr4ytln2hvn3ah/verified50datasets_vegetables.docx?dl=0)** -- 50 relevant datastes

If you want to learn more about the sources of this data:
- **[Data.gov](https://www.data.gov)** -- Official site of the US Government
- **[Open Indy Data Portal](http://data.indy.gov/)** -- Official site of the State of Indiana for open data

You can read more about these datasets [here](Datasets.md)

### 2. Readme File
Please make sure that you also include very descriptive readme file when you commit your application.
- **[Example README](readme_template)**

### 3. Example Submission of a Mashup   

An example submission of a mashup has been completed to get you started (but you do not have to use it). It can be found via the following link. In this example submission, AJAX is used for data retrieval, Google Map Api and D3 are applied for data display.

- **[Dev Process](sample_project)** -- This is a example submission of a mashup. Please keep in mind that is NOT related to your challenge question in the Purdue Gold IronHacks Spring 2017 <br>
- **[Demo of Example Project](http://rawgit.com/goldironhack/2017-Purdue-IronHack-Tutorials/master/sample_project/2017-Purdue-IronHacks-Tutorial-Project.html)**

### 4. Virtual Tutoring Sessions

We will be available for online Q&As on Wednesdays and Fridays. Please check www.ironhacks.com

<i>If you have done all this, you are ready to go! GOOD LUCK during the competition! You can do it! </i>
